var VERSION = 2.6;
var curPage = new Array();
var startPage = new Array();
var endPage = new Array();
var lastPage = new Array();
var resultsPerPage = new Array();
var totalResults = new Array();
var resultsArr = new Array();
var summaryArr = new Array();
var pagebarArr = new Array();
var curTab = 0;
var searchIn = "All torrents";
var sortDirection = "Down";
var sortCategory = "Name";
var startTab = 0;

// Execute the script on load
window.addEventListener('load',function(ev){
	// add behavior to the config button on the front side
	document.getElementById('configfront').addEventListener('click',function(ev){
		flipWidget("back");
	}, false);

	// add behavior to the config button on the back side
	document.getElementById('configback').addEventListener('click',function(ev){
		flipWidget("front");
	}, false);

	// add behavior to the close button
	document.getElementById('closefront').addEventListener('click',function(ev){
		window.close();
	}, false);

	// add behavior to the close button
	document.getElementById('closeback').addEventListener('click',function(ev){
		window.close();
	}, false);

	// add behavior to the reload button
	document.getElementById('reloadfront').addEventListener('click',function(ev){
		window.location.reload();
	}, false);

	// add behavior to the reload button
	document.getElementById('reloadback').addEventListener('click',function(ev){
		window.location.reload();
	}, false);
	
	// add behavior to the minimize button
	document.getElementById('minibutton').addEventListener('click',function(ev){
		toggleMiniMode('minimize');
	}, false);

	// add behavior to the maximize button
	document.getElementById('maxbutton').addEventListener('click',function(ev){
		toggleMiniMode('maximize');
	}, false);

	// add behavior to the reload button
	document.getElementById('expandDiv').addEventListener('click',function(ev){
		toggleResults();
	}, false);
	
/********
	// add behavior to the left arrow (scroll tabs left)
	document.getElementById('leftarrowDiv').addEventListener('click',function(ev){
		startTab--;
		if (curTab > startTab+6)
			curTab = startTab+6;
		createTabs(true);
	}, false);

	// add behavior to the right arrow (scroll tabs right)
	document.getElementById('rightarrowDiv').addEventListener('click',function(ev){
		startTab++;
		if (curTab < startTab)
			curTab = startTab;
		createTabs(true);
	}, false);
*******/

	// add behavior to the go/search button
	document.getElementById('gobutton').addEventListener('click',function(ev){
		var sites = document.getElementById('inUseList').options;
		var length = sites.length;
		var key = document.getElementById('searchText').value

		if (document.getElementById('checkbox').checked)
			addHistory(key);

		if (document.getElementById('expand').src.match('images/arrowdown.png'))
			showResults();

		for (var i=0; i<length; i++) {
			startPage[i] = 1;
			endPage[i] = 10;
			curPage[i] = 1;
			var site = sites[i].text
			resultsPerPage[i] = widget.preferenceForKey(site+'ResultsPerPage');
			getResults(site, key, i);
		}
	}, false);
	// pick up Enter in search field
	document.getElementById('searchText').addEventListener('keypress',function(ev){
		if (ev.keyCode == 13){
			var sites = document.getElementById('inUseList').options;
			var length = sites.length;
			var key = document.getElementById('searchText').value

			if (document.getElementById('checkbox').checked)
				addHistory(key);
			
			if (document.getElementById('expand').src.match('images/arrowdown.png'))
				showResults();

			for (var i=0; i<length; i++) {
				startPage[i] = 1;
				endPage[i] = 10;
				curPage[i] = 1;
				var site = sites[i].text
				resultsPerPage[i] = widget.preferenceForKey(site+'ResultsPerPage');
				getResults(site, key, i);
			}
		}
	},false);
	// pick up Enter in mini mode search field
	document.getElementById('miniText').addEventListener('keypress',function(ev){
		if (ev.keyCode == 13){
			document.getElementById('searchText').value = document.getElementById('miniText').value;
			toggleMiniMode('maximize');
			
			if (document.getElementById('expand').src.match('images/arrowdown.png'))
				showResults();

			var sites = document.getElementById('inUseList').options;
			var length = sites.length;
			var key = document.getElementById('miniText').value;	

			if (document.getElementById('checkbox').checked)
				addHistory(key);
			
			for (var i=0; i<length; i++) {
				startPage[i] = 1;
				endPage[i] = 10;
				curPage[i] = 1;
				var site = sites[i].text
				resultsPerPage[i] = widget.preferenceForKey(site+'ResultsPerPage');
				getResults(site, key, i);
			}
		}
	},false);
	
	// add behavior to the search history checkbox
	document.getElementById('checkbox').addEventListener('click',function(ev){
		if (this.checked == true) 
			widget.setPreferenceForKey('true','checked');
		else {		
			// clear any existing search history
			var list = document.getElementById('searchSelect');
			var blank = document.createElement('select');
			list.parentNode.insertBefore(blank, list);
			list.parentNode.removeChild(list);
			blank.id = 'searchSelect';

			for (var i=0; i<50; i++)
				widget.setPreferenceForKey('', 'searchHistory'+i);

			widget.setPreferenceForKey('false','checked');
		}
	}, false);
},false);


function e(str) { opera.postError(str); }
function gbid(id) { return document.getElementById(id); }

//load preferences
function loadPrefs() {
	window.resizeTo(473,125);
	
	checkVersion();

	var dropdown = document.getElementById('siteList');
	var inuseList = document.getElementById('inUseList');
	var availList = document.getElementById('availableList');

	// if this if the first time running this widget, load defaults
	if (widget.preferenceForKey('notFirstTime')!='true') {  
		widget.setPreferenceForKey('true','notFirstTime');
		loadDefaults();
	}

	//populate "In Use" and "Available lists
	if (widget.preferenceForKey('Torrentz')=='a')
		availList.add(new Option('Torrentz'));      
	else  inuseList.add(new Option('Torrentz'));      
	if (widget.preferenceForKey('BTJunkie')=='a')
		availList.add(new Option('BTJunkie'));      
	else  inuseList.add(new Option('BTJunkie'));      
	if (widget.preferenceForKey('isoHunt')=='a')
		availList.add(new Option('isoHunt'));      
	else  inuseList.add(new Option('isoHunt'));      
	if (widget.preferenceForKey('BTMon')=='a')
		availList.add(new Option('BTMon'));      
	else  inuseList.add(new Option('BTMon'));      
//	if (widget.preferenceForKey('TorrentSpy')=='a')
//		availList.add(new Option('TorrentSpy'));      
//	else  inuseList.add(new Option('TorrentSpy'));      
	if (widget.preferenceForKey('ThePirateBay')=='a')
		availList.add(new Option('ThePirateBay'));      
	else  inuseList.add(new Option('ThePirateBay'));      
	if (widget.preferenceForKey('Mininova')=='a')
		availList.add(new Option('Mininova'));      
	else  inuseList.add(new Option('Mininova'));      
	if (widget.preferenceForKey('SeedPeer')=='a')
		availList.add(new Option('SeedPeer'));      
	else  inuseList.add(new Option('SeedPeer'));      
	if (widget.preferenceForKey('TorrentPortal')=='a')
		availList.add(new Option('TorrentPortal'));      
	else  inuseList.add(new Option('TorrentPortal'));      
//	if (widget.preferenceForKey('TorrentReactor')=='a')
//		availList.add(new Option('TorrentReactor'));      
//	else  inuseList.add(new Option('TorrentReactor'));      
	if (widget.preferenceForKey('Demonoid')=='a')
		availList.add(new Option('Demonoid'));      
	else  inuseList.add(new Option('Demonoid'));      
	if (widget.preferenceForKey('TorrentBox')=='a')
		availList.add(new Option('TorrentBox'));      
	else  inuseList.add(new Option('TorrentBox'));      
//	if (widget.preferenceForKey('SnarfIt')=='a')
//		availList.add(new Option('SnarfIt'));      
//	else  inuseList.add(new Option('SnarfIt'));      
	
	if (inuseList.options.length > 0)
		curTab = 0;
	else  curTab = -1;
	createTabs();
	
	// load search history
	var term;
	var list = document.getElementById('searchSelect');
	list.options.length = 0;
	for (var i=0; i<50; i++) {
		term = widget.preferenceForKey('searchHistory'+i);
		if (term != "")
			list[i] = new Option(term);
	}
	
	// load channel checkbox value
	document.getElementById('checkbox').checked = (widget.preferenceForKey('checked')=='true'?true:false);

	// have to set selectedIndex outside of the javascript interpreter because of some strange bug;
	window.setTimeout(function() {list.selectedIndex = -1;}, 0);
}


//load defaults
function loadDefaults() {
/**** testing purposes only
//clear out search history
for(var i=0; i<50; i++)
widget.setPreferenceForKey('','searchHistory'+i);
****/
  // search history checkbox - yes by default
  widget.preferenceForKey('true', 'checked');

  // available sites to search
//  widget.setPreferenceForKey('i','BitTorrent');
  widget.setPreferenceForKey('i','Torrentz');
  widget.setPreferenceForKey('i','BTJunkie');
  widget.setPreferenceForKey('i','isoHunt');
  widget.setPreferenceForKey('i','BTMon');
  widget.setPreferenceForKey('i','TorrentSpy');
  widget.setPreferenceForKey('i','ThePirateBay');
  widget.setPreferenceForKey('i','Mininova');
  widget.setPreferenceForKey('i','SeedPeer');
  widget.setPreferenceForKey('i','TorrentPortal');
//  widget.setPreferenceForKey('i','TorrentReactor');
  widget.setPreferenceForKey('i','Demonoid');
  widget.setPreferenceForKey('i','TorrentBox');
//  widget.setPreferenceForKey('i','SnarfIt');
  
  // results per page for each site
  widget.setPreferenceForKey('10','BitTorrentResultsPerPage');
  widget.setPreferenceForKey('50','TorrentzResultsPerPage');
  widget.setPreferenceForKey('50','BTJunkieResultsPerPage');
  widget.setPreferenceForKey('20','isoHuntResultsPerPage');
  widget.setPreferenceForKey('50','BTMonResultsPerPage');
  widget.setPreferenceForKey('50','TorrentSpyResultsPerPage');
  widget.setPreferenceForKey('30','ThePirateBayResultsPerPage');
  widget.setPreferenceForKey('250','MininovaResultsPerPage');
  widget.setPreferenceForKey('50','SeedPeerResultsPerPage');
  widget.setPreferenceForKey('50','TorrentPortalResultsPerPage');
//  widget.setPreferenceForKey('100','TorrentReactorResultsPerPage');
  widget.setPreferenceForKey('50','DemonoidResultsPerPage');
  widget.setPreferenceForKey('100','TorrentBoxResultsPerPage');
//  widget.setPreferenceForKey('100','SnarfItResultsPerPage');
 
  // parameter used for sorting
  widget.setPreferenceForKey('','BitTorrentSortNameDown');
  widget.setPreferenceForKey('&s=n','TorrentzSortNameDown');
  widget.setPreferenceForKey('&o=42','BTJunkieSortNameDown');
  widget.setPreferenceForKey('&ihs1=1&iho1=a','isoHuntSortNameDown');
  widget.setPreferenceForKey('/name','BTMonSortNameDown');
  widget.setPreferenceForKey('','TorrentSpySortNameDown');
  widget.setPreferenceForKey('&orderby=name','ThePirateBaySortNameDown');  
  widget.setPreferenceForKey('/name/','MininovaSortNameDown');  
  widget.setPreferenceForKey('1','SeedPeerSortNameDown');  
  widget.setPreferenceForKey('&sort=filename&d=desc','TorrentPortalSortNameDown');  
//  widget.setPreferenceForKey('name','TorrentReactorSortNameDown');  
//  widget.setPreferenceForKey('&orderBy=name&orderByDir=DESC','SnarfItSortNameDown');  
  widget.setPreferenceForKey('','BitTorrentSortNameUp');
  widget.setPreferenceForKey('&s=N','TorrentzSortNameUp');
  widget.setPreferenceForKey('&o=41','BTJunkieSortNameUp');
  widget.setPreferenceForKey('&ihs1=1&iho1=d','isoHuntSortNameUp');
  widget.setPreferenceForKey('/NAME','BTMonSortNameUp');
  widget.setPreferenceForKey('','TorrentSpySortNameUp');
  widget.setPreferenceForKey('&orderby=name','ThePirateBaySortNameUp');  
  widget.setPreferenceForKey('/name/','MininovaSortNameUp');  
  widget.setPreferenceForKey('1','SeedPeerSortNameDown');  
  widget.setPreferenceForKey('&sort=filename&d=asc','TorrentPortalSortNameUp');  
//  widget.setPreferenceForKey('name','TorrentReactorSortNameUp');  
//  widget.setPreferenceForKey('&orderBy=name&orderByDir=ASC','SnarfItSortNameUp');  

  widget.setPreferenceForKey('','BitTorrentSortSizeDown');
  widget.setPreferenceForKey('&s=S','TorrentzSortSizeDown');
  widget.setPreferenceForKey('&o=62','BTJunkieSortSizeDown');
  widget.setPreferenceForKey('&ihs1=4&iho1=d','isoHuntSortSizeDown');
  widget.setPreferenceForKey('/SIZE','BTMonSortSizeDown');
  widget.setPreferenceForKey('','TorrentSpySortSizeDown');
  widget.setPreferenceForKey('&orderby=size','ThePirateBaySortSizeDown');  
  widget.setPreferenceForKey('/size/','MininovaSortSizeDown');  
  widget.setPreferenceForKey('3','SeedPeerSortSizeDown');  
  widget.setPreferenceForKey('&sort=size&d=desc','TorrentPortalSortSizeDown');  
//  widget.setPreferenceForKey('size','TorrentReactorSortSizeDown');  
//  widget.setPreferenceForKey('&orderBy=size&orderByDir=DESC','SnarfItSortSizeDown');  
  widget.setPreferenceForKey('','BitTorrentSortSizeUp');
  widget.setPreferenceForKey('&s=s','TorrentzSortSizeUp');
  widget.setPreferenceForKey('&o=61','BTJunkieSortSizeUp');
  widget.setPreferenceForKey('&ihs1=4&iho1=a','isoHuntSortSizeUp');
  widget.setPreferenceForKey('/size','BTMonSortSizeUp');
  widget.setPreferenceForKey('','TorrentSpySortSizeUp');
  widget.setPreferenceForKey('&orderby=size','ThePirateBaySortSizeUp');  
  widget.setPreferenceForKey('/size/','MininovaSortSizeUp');  
  widget.setPreferenceForKey('3','SeedPeerSortSizeDown');  
  widget.setPreferenceForKey('&sort=size&d=asc','TorrentPortalSortSizeUp');  
//  widget.setPreferenceForKey('size','TorrentReactorSortSizeUp');  
//  widget.setPreferenceForKey('&orderBy=size&orderByDir=ASC','SnarfItSortSizeUp');  

  widget.setPreferenceForKey('','BitTorrentSortAgeDown');
  widget.setPreferenceForKey('&s=A','TorrentzSortAgeDown');
  widget.setPreferenceForKey('&o=72','BTJunkieSortAgeDown');
  widget.setPreferenceForKey('&ihs1=6&iho1=d','isoHuntSortAgeDown');
  widget.setPreferenceForKey('/UPLOADED','BTMonSortAgeDown');
  widget.setPreferenceForKey('','TorrentSpySortAgeDown');
  widget.setPreferenceForKey('&orderby=age','ThePirateBaySortAgeDown');  
  widget.setPreferenceForKey('/added/','MininovaSortAgeDown');  
  widget.setPreferenceForKey('2','SeedPeerSortAgeDown');  
  widget.setPreferenceForKey('&sort=id&d=desc','TorrentPortalSortAgeDown');  
//  widget.setPreferenceForKey('added','TorrentReactorSortAgeDown');  
//  widget.setPreferenceForKey('&orderBy=added&orderByDir=DESC','SnarfItSortAgeDown');  
  widget.setPreferenceForKey('','BitTorrentSortAgeUp');
  widget.setPreferenceForKey('&s=a','TorrentzSortAgeUp');
  widget.setPreferenceForKey('&o=71','BTJunkieSortAgeUp');
  widget.setPreferenceForKey('&ihs1=6&iho1=a','isoHuntSortAgeUp');
  widget.setPreferenceForKey('/uploaded','BTMonSortAgeUp');
  widget.setPreferenceForKey('','TorrentSpySortAgeUp');
  widget.setPreferenceForKey('&orderby=age','ThePirateBaySortAgeUp');  
  widget.setPreferenceForKey('/added/','MininovaSortAgeUp');  
  widget.setPreferenceForKey('2','SeedPeerSortAgeUp');  
  widget.setPreferenceForKey('&sort=id&d=asc','TorrentPortalSortAgeUp');  
//  widget.setPreferenceForKey('added','TorrentReactorSortAgeUp');  
  widget.setPreferenceForKey('&orderBy=added&orderByDir=ASC','SnarfItSortAgeUp');  

  widget.setPreferenceForKey('','BitTorrentSortSeedDown');
  widget.setPreferenceForKey('&s=U','TorrentzSortSeedDown');
  widget.setPreferenceForKey('&o=52','BTJunkieSortSeedDown');
  widget.setPreferenceForKey('&ihs1=2&iho1=d','isoHuntSortSeedDown');
  widget.setPreferenceForKey('/SEEDERS','BTMonSortSeedDown');
  widget.setPreferenceForKey('','TorrentSpySortSeedDown');
  widget.setPreferenceForKey('&orderby=se','ThePirateBaySortSeedDown');  
  widget.setPreferenceForKey('/seeds/','MininovaSortSeedDown');  
  widget.setPreferenceForKey('4','SeedPeerSortSeedDown');  
  widget.setPreferenceForKey('&sort=seeders&d=desc','TorrentPortalSortSeedDown');  
//  widget.setPreferenceForKey('&orderBy=cached_seeds&orderByDir=DESC','SnarfItSortSeedDown');  
  widget.setPreferenceForKey('','BitTorrentSortSeedUp');
  widget.setPreferenceForKey('&s=u','TorrentzSortSeedUp');
  widget.setPreferenceForKey('&o=51','BTJunkieSortSeedUp');
  widget.setPreferenceForKey('&ihs1=2&iho1=a','isoHuntSortSeedUp');
  widget.setPreferenceForKey('/seeders','BTMonSortSeedUp');
  widget.setPreferenceForKey('','TorrentSpySortSeedUp');
  widget.setPreferenceForKey('&orderby=se','ThePirateBaySortSeedUp');  
  widget.setPreferenceForKey('/seeds/','MininovaSortSeedUp');  
  widget.setPreferenceForKey('4','SeedPeerSortSeedUp');  
  widget.setPreferenceForKey('&sort=seeders&d=asc','TorrentPortalSortSeedUp');  
//  widget.setPreferenceForKey('&orderBy=cached_seeds&orderByDir=ASC','SnarfItSortSeedUp');  

  widget.setPreferenceForKey('','BitTorrentSortLeechDown');
  widget.setPreferenceForKey('&s=D','TorrentzSortLeechDown');
  widget.setPreferenceForKey('&o=32','BTJunkieSortLeechDown');
  widget.setPreferenceForKey('&ihs1=3&iho1=d','isoHuntSortLeechDown');
  widget.setPreferenceForKey('/LEECHERS','BTMonSortLeechDown');
  widget.setPreferenceForKey('','TorrentSpySortLeechDown');
  widget.setPreferenceForKey('&orderby=le','ThePirateBaySortLeechDown');  
  widget.setPreferenceForKey('/leech/','MininovaSortLeechDown');  
  widget.setPreferenceForKey('5','SeedPeerSortLeechDown');  
  widget.setPreferenceForKey('&sort=leechers&d=desc','TorrentPortalSortLeechDown');  
//  widget.setPreferenceForKey('&orderBy=cached_peers&orderByDir=DESC','SnarfItSortLeechDown');  
  widget.setPreferenceForKey('','BitTorrentSortLeechUp');
  widget.setPreferenceForKey('&s=d','TorrentzSortLeechUp');
  widget.setPreferenceForKey('&o=31','BTJunkieSortLeechUp');
  widget.setPreferenceForKey('&ihs1=3&iho1=a','isoHuntSortLeechUp');
  widget.setPreferenceForKey('/leechers','BTMonSortLeechUp');
  widget.setPreferenceForKey('','TorrentSpySortLeechUp');
  widget.setPreferenceForKey('&orderby=le','ThePirateBaySortLeechUp');  
  widget.setPreferenceForKey('/leech/','MininovaSortLeechDown');  
  widget.setPreferenceForKey('5','SeedPeerSortLeechUp');  
  widget.setPreferenceForKey('&sort=leechers&d=desc','TorrentPortalSortLeechUp');  
//  widget.setPreferenceForKey('&orderBy=cached_peers&orderByDir=ASC','SnarfItSortLeechUp');  
}


// Perform the flipping of the widget
function flipWidget(to){
  switch (to) {
    case 'back':
      document.getElementById('frontview').style.display = 'none';
      document.getElementById('configview').style.display = 'block';
		window.resizeTo(473,230);
      break;
    case 'front':
      document.getElementById('configview').style.display = 'none';
      document.getElementById('frontview').style.display = 'block';
      
      if (widget.preferenceForKey('need refresh')=='true')
         createTabs();

		if (document.getElementById('expand').src.match('images/arrowdown.png'))
			window.resizeTo(473,125);
      else  window.resizeTo(473,420);
		
		break;
    default:
      // do nothing
      break;
  }
}


// compare version with latest version available, display upgrade message if newer available.
function checkVersion() {
	var	url = 'http://widgets.opera.com/widget/doap/6012/';
	var xmlhttp=new XMLHttpRequest();
	xmlhttp.open('GET',url,true);
	xmlhttp.setRequestHeader('Content-length', 2);
	xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
	xmlhttp.onreadystatechange = function() {
		if (xmlhttp.readyState==4) {
			var vers = xmlhttp.responseXML.getElementsByTagName('name')[2].childNodes[0].nodeValue;
			vers = parseFloat(vers);
			if (vers > VERSION)
				gbid('upgrade').style.display = 'block';
		}
	};
  	xmlhttp.send(null);
}


// toggle between minimized and maximize versions
function toggleMiniMode(dir) {
	if (dir=='minimize') {
		document.getElementById('frontview').style.display = 'none';
		document.getElementById('miniview').style.display = 'block';	
	}
	else if (dir=='maximize') {
		document.getElementById('frontview').style.display = 'block';
		document.getElementById('miniview').style.display = 'none';	
	}
}

function createTabs(keepResults) {
	var inuseOptions = document.getElementById('inUseList').options;
	var length = inuseOptions.length;
	var tabspane = document.getElementById('tabsPane');

	// clear any previous tabs
	if (!keepResults) {
		resultsArr.length = 0;
		summaryArr.length = 0;
		pagebarArr.length = 0;
	}
	
	// create new tabs
	var name;
	var tabslist = document.getElementById('tabsList');
	tabslist.innerHTML = '';

	// add left arrow if more tabs than can fit on screen and have scrolled to the right
	if (startTab > 0)
	   document.getElementById('leftarrowDiv').style.display = "block";
	else  document.getElementById('leftarrowDiv').style.display = "none";

	for (var i=0; i<length; i++) {
		// add tab to tab bar
		name = inuseOptions[i].text;
		var tab = document.createElement('span');
		tab.innerHTML = name;
		tab.onclick = 'showTab('+i+')';
		tab.className = 'tab';
//		if (i < startTab || i >= startTab + 7)
//			tab.style.display = "none";

		tabslist.appendChild(tab);
		
		// create divs
		if (!keepResults) {
			resultsArr[i] = document.createElement('div');
			summaryArr[i] = document.createElement('div');
			pagebarArr[i] = document.createElement('div');
		
			summaryArr[i].className = 'summary';
			resultsArr[i].className = 'results';	
			pagebarArr[i].className = 'pageBar';
		}
	}
	
	// add right if more tabs than can fit on screen and aren't scrolled all the way over
	if (startTab+6 < length-1)
	   document.getElementById('rightarrowDiv').style.display = "block";
	else  document.getElementById('rightarrowDiv').style.display = "none";

	// initialize associated variables
	if (!keepResults) {
		var curPage = new Array();
		var startPage = new Array();
		var endPage = new Array();
		var lastPage = new Array();
		var resultsPerPage = new Array();
		var totalResults = new Array();
	}
	
	showTab(curTab);
}


//add current search term to the search history drop down
function addHistory(key) {
	var list = document.getElementById('searchSelect');

	// first make sure key isn't already in history
	for (var i=0; i<list.length; i++)
		if (key==list.options[i].value)
			return;

	// move all terms down one (most recent at top)	
	list.options[list.length] = (new Option(key));
	var val;
	for (var i=list.length-2; i>=0; i--) {
		val = list.options[i].value;
		list.options[i+1].value = val;
		list.options[i+1].text = val;
		widget.setPreferenceForKey(val, 'searchHistory'+(i+1));
	}
	list.options[0].value = key;
	list.options[0].text = key;
	widget.setPreferenceForKey(key, 'searchHistory'+0);
}


// Do the search
function getResults(site, searchkey, divid) {
	var url;
	var key = searchkey;
	var xmlhttp=new XMLHttpRequest();
	
	summaryArr[divid].innerHTML = "Loading results...";
	resultsArr[divid].innerHTML = "";
	pagebarArr[divid].innerHTML = "";
	
	switch(site) {
//		case 'BitTorrent': 
//			url = "http://www.bittorrent.com/search_result.html?search=" + key + "&start_result=" + (curPage[divid]-1)*10;
//			break;
		case 'Torrentz': 
			key = key.replace(/ /gi,'-');
			url = "http://www.torrentz.com/search?q=" + key + "&p=" + (curPage[divid]-1) + widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
			break;
		case 'BTJunkie': 
			key = key.replace(/ /gi,'+');
			url = "http://btjunkie.org/search?q=" + key + "&p=" + curPage[divid] + widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
			break;
		case 'isoHunt': 
			key = key.replace(/ /gi,'+');
			url = "http://isohunt.com/torrents/?ihq=" + key + "&ihp=" + curPage[divid]  + widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
			break;
		case 'BTMon': 
			url = "http://www.btmon.com/torrent/0/" + key + widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection) + "/page" + curPage[divid];
			break;
//		case 'TorrentSpy': 
//			key = key.replace(/ /gi,'+');
//			url = "http://torrentspy.com/search/" + key + "?pg=" + curPage[divid] + widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
//			break;
		case 'ThePirateBay': 
			key = key.replace(/ /gi,'+');
			url = "http://thepiratebay.org/search.php?q=" + key + widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
			break;
		case 'Mininova': 
			key = key.replace(/ /gi,'+');
			sort = widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
			if (sort=="")
				sort = "/added/";
			url = "http://www.mininova.org/search/" + key + sort + curPage[divid];
			break;
		case 'SeedPeer': 
			key = key.replace(/ /gi,'+');
			sort = widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
			url = "http://www.seedpeer.com/search/" + key + "/" + sort + "/" + curPage[divid] + ".html";
			break;
		case 'TorrentPortal': 
			key = key.replace(/ /gi,'+');
			sort = widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
			url = "http://torrentportal.com/torrents-search.php?search=" + key + sort + "&page=" + (curPage[divid]-1);
			break;
//		case 'TorrentReactor': 
//			key = key.replace(/ /gi,'%20');
//			url = "http://www.torrentreactor.to/torrents/search/" + key + "/" + ((curPage[divid]-1)*100) + "/" + widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
//			break;
		case 'Demonoid': 
			key = key.replace(/ /gi,'+');
			url = "http://www.demonoid.com/files/?query=" + key + "&page=" + (curPage[divid]-1) + widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
			break;
		case 'TorrentBox': 
			key = key.replace(/ /gi,'+');
			url = "http://www.torrentbox.com/torrents-search.php?search=" + key + "&page=" + (curPage[divid]-1) + "&cat=0&submit=TBox+Search";
			break;
//		case 'SnarfIt': 
//			key = key.replace(/ /gi,'+');
//			url = "http://www.snarf-it.org/pages/search.html?query=" + key + "&pageNo=" + (curPage[divid]) + widget.preferenceForKey(site+'Sort'+sortCategory+sortDirection);
//			break;
			
		default:
			// do nothing
			break;
	}

	if (site == 'ThePirateBay') {
		xmlhttp.open("POST",url,true);
		xmlhttp.setRequestHeader("Content-length", 2);
		xmlhttp.setRequestHeader("Connection", "close");	
	}
	else  xmlhttp.open("GET", url, true);
	
	xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');

	var callbackfunc = new callback(xmlhttp, site, searchkey, divid);
	xmlhttp.onreadystatechange = callbackfunc.invoke;

	if (site == 'ThePirateBay') 
		xmlhttp.send('q='+key+'&page='+(curPage[divid]-1));
	else  xmlhttp.send(null);
}

function callback(xmlhttp, site, key, divid) {
	this.xmlhttp = xmlhttp;
	this.site = site;
	this.key = key;
	this.divid = divid;
	var me = this;
	
	this.invoke=function () {
		if (xmlhttp.readyState==4) {
			var tmpdiv=document.createElement('div');
			tmpdiv.innerHTML = xmlhttp.responseText;
			var torrents = processResults(site, key, tmpdiv, divid);

			if (torrents==null)
				return;

			var length=torrents.length;
			var resultsDiv = document.createElement('div');
			resultsDiv.innerHTML = '<table><tr padding=1px; style="text-align: left"><th>DL</th><th><a href="#" onclick="sortResults(\'Name\')">Name</a></th><th><a href="#" onclick="sortResults(\'Size\')">Size</a></th><th><a href="#" onclick="sortResults(\'Seed\')">S</a></th><th><a href="#" onclick="sortResults(\'Leech\')">L</a></th></tr>';
/***
resultsDiv.innerHTML = resultsDiv.innerHTML.replace(/(<th>.*Name.*?)<\/th>/i,'$1<img src="images/arrowdown.png" height="6px"><\/th>');
opera.postError('html: '+resultsDiv.innerHTML);
***/
			for (var i=0; i<length; i++) {
				resultsDiv.innerHTML+='<tr><td>' + (torrents[i].dllink!=""?'<a href="#" onclick="widget.openURL(\''+torrents[i].dllink+'\')"><img src="images/down.gif"></a>':'?') + '</td><td width="220"><a href="#" onclick="widget.openURL(\''+torrents[i].infolink+'\')">'+torrents[i].name+'</a></td><td width="65">'+torrents[i].size+'</td><td width="20">'+torrents[i].seeders+'</td><td width="20">'+torrents[i].leechers+'</td></tr>';
				
				/**** using above table structure instead
				var item = document.createElement('div');
				item.className = "item";
				item.innerHTML = "<span onclick='toggleDesc("+i+")' class='itemTitle' id='item"+i+"' title="+torrents[i].name+"><img src='images/plus.png' id='itemIcon"+i+"' alt='>'>"+torrents[i].name+"</span><span class='itemLink'><a href='"+torrents[i].infolink+"'>(open)</a></span>"+
				"<span class='itemDesc' id='itemDesc"+i+"'><a id='link"+i+"' href='"+torrents[i].dllink+"'>Download torrent</a><br>"+torrents[i].description+torrents[i].seeders+" seeders, "+torrents[i].leechers+" downloaders</span>";
        
				if (torrents[i].dllink=='')  // for now deal with Torrentz case - no direct download link
					item.innerHTML = item.innerHTML.replace(/Download Torrent/gi,'').replace(/<br>/gi,'');

				resultsDiv.appendChild(item);
				****/
			}
			resultsDiv.innerHTML += '</table>';

			results = resultsArr[divid];
			results.innerHTML = resultsDiv.innerHTML;
			genPageBar(site, divid);	
//opera.postError('results: '+results.innerHTML);


			if (divid == curTab)	// refresh info
				showTab(curTab);
		}
	};
}  


function sortResults(type) {
	sortCategory = type;
//var div = document.getElementById(type+sortDirection).class = "arrowOn";
	if (sortDirection==null || sortDirection.match('Down'))
		sortDirection = 'Up'
	else  sortDirection = 'Down';
/***
var div = document.getElementById(type+sortDirection);
opera.postError('html: '+div.innerHTML);
div.style.display = "block";
opera.postError(type+sortDirection);
****/
	var sites = document.getElementById('inUseList').options;
	var length = sites.length;
	var key = document.getElementById('searchText').value

	for (var i=0; i<length; i++) {
		startPage[i] = 1;
		endPage[i] = 10;
		curPage[i] = 1;
		var site = sites[i].text
		resultsPerPage[i] = widget.preferenceForKey(site+'ResultsPerPage');
		getResults(site, key, i);
	}
}



/*** not used with new table structure
function toggleDesc(id) {
  var elem;
  var img;
  if (elem = document.getElementById("itemDesc"+id)) {
    if (elem.style.display == "none" || !elem.style.display) {
      elem.style.display = "block";  
      if (img = document.getElementById("itemIcon"+id)) 
        img.src = "images/minus.png";
    } 
    else {
      elem.style.display = "none";
      if (img = document.getElementById("itemIcon"+id))
        img.src = "images/plus.png";
    }
  }
}
***/

// show the specified page of results
function goToPage(num, site, divid) {
	if (num < startPage[divid] || num > endPage[divid]) {
		// on last page of grouping and going to next page (or hit '>>' link), so change start and end page
		if (num > curPage[divid] && (curPage[divid]%10 == 0 || (num-curPage[divid] > 1) )) {
			startPage[divid] += 10;
			if (startPage[divid] > lastPage[divid])
				startPage[divid] = lastPage[divid];
			endPage[divid] += 10;
			if (endPage[divid] > lastPage[divid])
			endPage[divid] = lastPage[divid];
		}

		// on first page of grouping and going to previous page (or hit '<<' link), so change start and end page
		else if (num < curPage[divid] && (curPage[divid]%10 == 1 || (curPage[divid]-num > 1)) && startPage[divid] > 10) {
			startPage[divid] -= 10;
			endPage[divid] -= 10;
		}
	}

	curPage[divid] = num;
	var div = document.getElementById(divid);
	var key = document.getElementById('searchText').value
	getResults(site, key, divid);
}


// create the page navigation div below the results
function genPageBar(site, divid) {
  var pagebar = pagebarArr[divid];
  
  // clear any previous data
  if (pagebar.hasChildNodes()) {
    var length = pagebar.childNodes.length;
    for (var i=0; i<length; i++)
      pagebar.removeChild(pagebar.childNodes[0]);  
  }

  var lbl = document.createElement('span');
  lbl.innerHTML = 'Page: ';
  pagebar.appendChild(lbl);


  /* now build page bar */
/****
  // for BTJunkie, we don't know total results, so just make links for cur, prev, and next.
  if (site == 'BTJunkie') {  
    var span1 = document.createElement('span');
    span1.innerHTML = '&lt;';
    span1.onclick = 'goToPage(' + (curPage[divid]-1) + ',"' + site + '",' + divid + ')';
    span1.className = 'pageBarItem';

    var span2 = document.createElement('span');
    span2.innerHTML = curPage[divid];
    span2.className = 'pageBarItem selectedPage';
	 
    var span3 = document.createElement('span');
    span3.innerHTML = '&gt;';
    span3.onclick = 'goToPage(' + (curPage[divid]+1) + ',"' + site + '",' + divid + ')';
    span3.className = 'pageBarItem';

    if (curPage[divid] > 1)
      pagebar.appendChild(span1);    
    pagebar.appendChild(span2);    
    pagebar.appendChild(span3);    

    return;
  }
***/
  
  // show previous page group link ("<<")
  if (startPage[divid] > 10) {
    var span = document.createElement('span');
    span.innerHTML = '&lt;&lt;';
    span.onclick = 'goToPage(' + (startPage[divid]-10) + ',"' + site + '",' + divid + ')';
    span.className = 'pageBarItem';
    pagebar.appendChild(span);    
  }

  // show previous page link ("<")
  if (curPage[divid] > 1) {
    var span = document.createElement('span');
    span.innerHTML = '&lt;';
    span.onclick = 'goToPage(' + (curPage[divid]-1) + ',"' + site + '",' + divid + ')';
    span.className = 'pageBarItem';
    pagebar.appendChild(span);    
  }

  // build page numbers
  for (var i=startPage[divid]; i<=endPage[divid] && i<=lastPage[divid]; i++) {
    var span = document.createElement('span');
    span.innerHTML = i;
    span.onclick = 'goToPage(' + (i) + ',"' + site + '",' + divid + ')';
    span.className = 'pageBarItem';
    if (i==curPage[divid])
      span.className = span.className + ' selectedPage';

    pagebar.appendChild(span); 
  }

  // show next page link (">") if not at last page already
  if (curPage[divid] != lastPage[divid]) {
    var span = document.createElement('span');
    span.innerHTML = '&gt;';
   span.onclick = 'goToPage(' + (curPage[divid]+1) + ',"' + site + '",' + divid + ')';
    span.className = 'pageBarItem';
    pagebar.appendChild(span);    
  }

  // show next page group, i.e. cur start page + 10 (">>") if not in the last grouping already
  if (lastPage[divid] > endPage[divid]) {
    var span = document.createElement('span');
    span.innerHTML = '&gt;&gt;';
    span.onclick = 'goToPage(' + (startPage[divid]+10) + ',"' + site + '",' + divid + ')';
    span.className = 'pageBarItem';
    pagebar.appendChild(span);    
  }
}


function showTab(tabnum) {
	if (tabnum < 0)
		return;

	spans = document.getElementById('tabsList').childNodes;
	if (curTab != -1)
		spans[curTab].className = 'tab';
	spans[tabnum].className = 'selectedtab';
	curTab = tabnum;

	// clear current contents of tab pane
	if (document.getElementById('resultsdiv').childNodes.length > 0)
		document.getElementById('resultsdiv').innerHTML="";
	if (document.getElementById('summarydiv').childNodes.length > 0)
		document.getElementById('summarydiv').innerHTML="";
	if (document.getElementById('pagebardiv').childNodes.length > 0)
		document.getElementById('pagebardiv').innerHTML="";	

	// set new contents
	document.getElementById('resultsdiv').appendChild(resultsArr[tabnum]);
	document.getElementById('summarydiv').appendChild(summaryArr[tabnum]);
	document.getElementById('pagebardiv').appendChild(pagebarArr[tabnum]);
}


function toggleResults() {
	if (document.getElementById('expand').src.match('images/arrowdown.png'))
		showResults();
	else  hideResults();
}


function showResults() {
  document.getElementById('tabsPane').style.display='block';

  var an1 = document.getElementById('middle').createAnimation();
  var an2 = document.getElementById('tabsPane').createAnimation();

  an1.addAnimation('height','50px','345px');
  an1.speed = 20;
  an1.accelerationProfile = an1.sine;

  an2.addAnimation('height','0px','270px');
  an2.speed = 20;
  an2.accelerationProfile = an2.sine;

  an2.run();
  an1.run();

  an1.onfinish = function() {
    document.getElementById('expand').src = 'images/arrowup.png';
    resultsArr[curTab].style.overflow='auto';
  }
 
  window.resizeTo(473,420);
}


function hideResults() {
	resultsArr[curTab].style.overflow='hidden';

  var an1 = document.getElementById('middle').createAnimation();
  var an2 = document.getElementById('tabsPane').createAnimation();
  an1.addAnimation('height','345px','50px');
  an1.speed = 20;
  an1.accelerationProfile = an1.sine;

  an2.addAnimation('height','270px','0px');
  an2.speed = 20;
  an2.accelerationProfile = an2.sine;


  an2.onfinish = function() {
    document.getElementById('expand').src = 'images/arrowdown.png';
  	 window.resizeTo(473,125);
  }

  an1.run();
  an2.run();
}


function processResults(site, key, resultsDiv, divid) {
  var torrents;

  switch(site) {
//    case 'BitTorrent': 
//      torrents = processBitTorrent(resultsDiv, key, divid);
//      break;
    case 'Torrentz': 
      torrents = processTorrentz(resultsDiv, key, divid);
      break;
    case 'BTJunkie': 
      torrents = processBTJunkie(resultsDiv, key, divid);
      break;
    case 'isoHunt': 
      torrents = processIsoHunt(resultsDiv, key, divid);
      break;
    case 'BTMon': 
      torrents = processBTMon(resultsDiv, key, divid);
      break;
    case 'TorrentSpy': 
      torrents = processTorrentSpy(resultsDiv, key, divid);
      break;
    case 'ThePirateBay': 
      torrents = processThePirateBay(resultsDiv, key, divid);
      break;
    case 'Mininova': 
      torrents = processMininova(resultsDiv, key, divid);
      break;
    case 'SeedPeer': 
      torrents = processSeedPeer(resultsDiv, key, divid);
      break;
    case 'TorrentPortal': 
      torrents = processTorrentPortal(resultsDiv, key, divid);
      break;
//    case 'TorrentReactor': 
//      torrents = processTorrentReactor(resultsDiv, key, divid);
//      break;
    case 'Demonoid': 
      torrents = processDemonoid(resultsDiv, key, divid);
      break;
    case 'TorrentBox': 
      torrents = processTorrentBox(resultsDiv, key, divid);
      break;
//    case 'SnarfIt': 
//      torrents = processSnarfIt(resultsDiv, key, divid);
//      break;
    default:
      // do nothing
      break;
  }

  return torrents;
}

/*********  BitTorrent currently not used
function processBitTorrent(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/did not match any/gi)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";

		return null;	
	}
	else {
		var sum = response.getElementsByTagName('h2')[0];
		totalResults[divid] = sum.innerHTML.replace(/\n/g,'').replace(/Results/g,'').replace(/in .*$/gi,'').replace(/For.*".*"?/,'').replace(/<\/?em>/gi,'');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var LIs = response.getElementsByTagName('LI');
	
	// parse out each list item
	var length = LIs.length
	var torrents = new Array();
	var seeders, leechers, dllink, infolink;
	var root = "http://www.bittorrent.com";
	for (var i=0; i<length; i++) {
		var div = LIs[i].childNodes[1].childNodes[2];  // div class="d"
		var a1 = div.childNodes[1];  // torrent info link 
		var desc = getElementsByClassName(div,'div','closedTri')[0].innerHTML;
		var size = desc.replace(/\n/g,'').replace(/<span.*?>.*?<\/span>/i,'').replace(/<div.*?>.*?<\/div>/i,'').replace(/\d+ files/,'');
		var nm = a1.innerHTML;
		nm = nm.replace(/<span class="token" id="\w*">/gi,'');
		nm = nm.replace(/<\/span>/gi,'');
	
		if (getElementsByClassName(div,'span','numSeeders')[0]==null)  // no seed info available
			seeders = 'NA';
		else  seeders = getElementsByClassName(div,'span','numSeeders')[0].innerHTML;  // # seeders
		if (getElementsByClassName(div,'span','numDownloaders')[0]==null)  // no leech info available
			leechers = 'NA';    
		else  leechers = getElementsByClassName(div,'span','numDownloaders')[0].innerHTML;  // # seeders

		dllink = root + div.childNodes[3].childNodes[9].outerHTML.replace(/<a href="/gi,'').replace(/Download Torrent<\/a>/gi,'').replace(/"*>/gi,'');
		infolink = dllink.replace(/download.html/gi,'');

		torrents[i] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}

	return torrents;
}
*********/

function processTorrentz(response, key, divid) {
  // set summary div
  var sumdiv = summaryArr[divid];
  if (response.innerHTML.match(/None found/)) {
    sumdiv.innerHTML = 'No matches found for "' + key + '".';

    // remove previous results
	resultsArr[divid].innerHTML="";

    return null;
  }
  else {
    totalResults[divid] = response.innerHTML.match(/Results .*? of \d(,*\d+)*/i,'')[0].replace(/.*? of (\d.*)/i,'$1');
    lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
    sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
  }

  var seedArr = getElementsByClassName(response,'span','u');
  var leechArr = getElementsByClassName(response,'span','d');
  var sizeArr = getElementsByClassName(response,'span','s');
  var nameArr = getElementsByClassName(response,'dt','');
  var torrents = new Array();
  var nm, infolink;
  var desc = '<div></div>';
  var root = 'http://www.torrentz.com';
  for (var i=1; i<leechArr.length; i++) {
    nm = nameArr[i].innerHTML.replace(/<a .*?>/i,'').replace(/<\/a>.*/i,'').replace(/<\/?b>/gi,'');
    infolink = root + nameArr[i].innerHTML.replace(/.*<a href="(.*?)">.*/gi,'$1');
    torrents[i-1] = new Torrent(trimName(nm), infolink,'', seedArr[i].innerHTML, leechArr[i].innerHTML, sizeArr[i].innerHTML, desc);
  }

  return torrents;
}


function processBTJunkie(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/Suggestions/gi)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';
	
		// remove previous results
		resultsArr[divid].innerHTML="";

		return null;
	}
	else {
		var sum = response.innerHTML.match(/Results.*trong>/gi)[1];
		totalResults[divid] = sum.replace(/Results.*?of /i,'').replace(/<\/?strong>/gi,'');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var table = getElementsByClassName(response,'table','tab_results')[0]; 
	table.innerHTML = table.innerHTML.replace(/\n/g,'');
	var nameArr = table.innerHTML.match(/<th width="60.*?<\/th>/gi);
	var sizeArr = table.innerHTML.match(/<th width="10.*?<\/th>/gi);
	var thArr = table.innerHTML.match(/<th width="5.*?<\/th>/gi);
	var leechArr = table.innerHTML.match(/00CED1" style="font-weight: bold;">.*?</gi);
	var root = 'http://btjunkie.org';
	var desc = '<div></div>';
	var seeders, leechers, infolink, dllink, nm, id, size;
	var torrents = new Array();
	for (var i=0; i<nameArr.length-1; i++) {
		seeders = thArr[i*3 + 4].replace(/<th .*?><font .*?>/i,'').replace(/<\/font><\/th>/i,'');
		if (seeders == 'X')
		seeders = '0';
		leechers = thArr[i*3 + 5].replace(/<th .*?><font .*?>/i,'').replace(/<\/font><\/th>/i,'');
		if (leechers == 'X')
			leechers = '0';    
		nm = nameArr[i+1].replace(/<\/?th.*?>/gi,'').replace(/<a .*?>/gi,'').replace(/<img.*?>/gi,'').replace(/<\/a>/gi,'').replace(/\s\s+/gi,'').replace(/<\/?table.*?>/gi,'').replace(/<\/?font.*?>/gi,'').replace(/<\/?tr>/gi,'').replace(/<\/?tbody>/gi,'');
		infolink = root + nameArr[i+1].replace(/<\/?th.*?>/gi,'').match(/<a.*?>/gi)[2].replace(/.*"(\/torrent.*?)".*/i,'$1');
		if (nameArr[i+1].match('auto_download'))
			dllink = nameArr[i+1].replace(/<\/?th.*?>/gi,'').match(/<a.*?>/gi)[0].replace('<A href="','').replace('" rel="nofollow" target="_blank">','');    
		else	dllink = nameArr[i+1].replace(/<\/?th.*?>/gi,'').match(/<a.*?>/gi)[0].replace(/.*"(.*?download.torrent)".*/i,'$1').replace('<A href="','').replace('" rel="nofollow">','');    
		size = sizeArr[i+1].replace(/<th .*?><font .*?>/i,'').replace(/<\/font><\/th>/i,'');
		torrents[i] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}

	return torrents;
}


function processIsoHunt(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/Search returned 0 results/gi)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";

		return null;
	}
	else {
		var sum = response.innerHTML.match(/Page.*?items\)/g)[0];
		totalResults[divid] = sum.replace(/.*\(/g,'').replace(/ items\)/gi,'').replace(/<\/?b.*?>/gi,'');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var trArr = getElementsByClassName(response,'tr','hlRow'); 
	var length = trArr.length;


///************** deal with double DL/REL link (isohunt release)

	var root = 'http://isohunt.com/';
	var desc = '<div></div>';
	var seeders, leechers, infolink, dllink, nm, size;
	var torrents = new Array();

	for (var i=1; i<length; i++) {  // skip first and last
		nm = trArr[i].childNodes[2].childNodes[1].innerHTML.replace(/<\/?b>/gi,'');//.replace(/\w*<br>/gi,'$1');
		size = trArr[i].childNodes[3].innerHTML;
		seeders = trArr[i].childNodes[4].innerHTML;
		if (seeders == '') 
			seeders = 0;
		leechers = trArr[i].childNodes[5].innerHTML;
		if (leechers == '') 
			leechers = 0;
 
		var id = trArr[i].outerHTML.match(/\/\d*\//gi)[0];
		infolink = root + 'torrent_details' + id;
		dllink = root + 'download' + id;
		torrents[i-1] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}

	return torrents;
}


function processBTMon(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/did not match any/gi)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
	
		return null;
	}
	else {
		var sum = response.innerHTML.match(/<span>\d\d+<\/span>.*Results for/i);//getElementsByClassName(response,'div','searchBar');
		sum = getElementsByClassName(response,'div','dirs');//[0];
		sum = sum[0].innerHTML.match(/<SPAN>.*?<\/SPAN> of <SPAN>\d+<\/SPAN>/i)[0];
		totalResults[divid] = sum.replace(/.* of <span>(\d+)<\/span>.*/i,'$1');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
		if (lastPage[divid] > 10)	// for some reason BTMon only shows 10 pages, even if there are more results
			lastPage[divid] = 10;
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var rows = response.innerHTML.match(/<tr onmouseover="this.className='hl_row'" onmouseout="this.className=''">(.+?\n*)+?<\/tr>/gi);
	var nameArr = getElementsByClassName(response,'*','long_word');
	var dllinkArr = response.innerHTML.match(/<a href="\/.*?" onclick=/gi);
	var tr = document.createElement('tr');
	var torrents = new Array();
	var seed, leech, dllink, infolink, desc, innerhtml, size;
	var root = 'http://www.btmon.com';
	for (var i=3; i<rows.length; i++) {	// loop through the 50 results, skip the sponsored ones at the beginning
		tr.innerHTML = rows[i].replace(/<\/?tr.*?>/i,'');
		size = tr.childNodes[3].innerHTML;
		seed = tr.childNodes[5].innerHTML.replace(/<\/?strong>/gi,'');
		leech = tr.childNodes[6].innerHTML;
		infolink = root + tr.innerHTML.match(/<a class="toolLinks" .*?">/i)[0].replace(/<a class="toolLinks" href="(.*?)">/i,'$1');
		dllink = infolink.replace(/.html/,'');
		desc = "";
		torrents[i-3] = new Torrent(trimName(nameArr[i-3].innerHTML), infolink, dllink, seed, leech, size, desc);
	}

  return torrents;
}


// not available to US users any more
function processTorrentSpy(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/did not result in any matches/gi)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
		return null;
	}
	else {
		var sum = response.innerHTML.match(/Torrents found: \d+/g)[0];
		totalResults[divid] = sum.replace(/.*\: /g,'');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var table = getElementsByClassName(response,'table','list')[0]; 
	var tds = getElementsByClassName(table,'td','');
	var root = 'http://torrentspy.com';
	var desc = '<div></div>';
	var seeders, leechers, infolink, dllink, nm, size;
	var torrents = new Array();

	var adjfactor = 0;
	for (var i=0; i<tds.length/7; i++) {  // skip first and last

		nm = tds[i*7].innerHTML.replace(/.*<b>(.*)<\/b>.*/i,'$1');
		size = tds[i*7 + 2].innerHTML;
		seeders = tds[i*7 + 4].innerHTML;
		if (seeders.match('refresh.gif')) 
			seeders = 0;
		leechers = tds[i*7 + 5].innerHTML;
		if (leechers.match('refresh.gif')) 
			leechers = 0;

		var id;
		if (tds[i*7].innerHTML.match('www.gamefly.com/ads')) {
			adjfactor++;	// gamefly ad, not real torrent link, so need to adjust number for torrents array
		}
		else {
			id = tds[i*7].innerHTML.replace(/.*href="(.*)" title="Download Torrent".*/,'$1').replace(/.*\/torrent\/(\d+)\/.*/i,'$1');
			infolink = root + '/torrent/' + id + '/';
			dllink = root + '/download.asp?id=' + id;
			torrents[i-adjfactor] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
		}
	}

	return torrents;
}

function processThePirateBay(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/did not match any torrents/gi)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
	
		return null;
	}

	var table = getElementsByClassName(response,'table','')[0]; 
	var tds = getElementsByClassName(table,'td','*');
	var root = 'http://thepiratebay.org';
	var desc = '<div></div>';
	var seeders, leechers, infolink, dllink, nm, size;
	var torrents = new Array();
	for (var i=0; i<(tds.length-1)/7; i++) {
		nm = tds[i*7+1].innerHTML.replace(/<\/?a.*?>/gi,'');
		size = tds[i*7 + 4].innerHTML;
		seeders = tds[i*7 + 5].innerHTML;
		leechers = tds[i*7 + 6].innerHTML; 
		dllink = tds[i*7 + 3].innerHTML.replace(/.*<a href="(.*?)".*/i,'$1');
		infolink = root + tds[i*7+1].innerHTML.replace(/.*<a href="(.*?)".*/i,'$1');
		torrents[i] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}
	
	// get last page
	if (tds[tds.length-1].innerHTML.match(/alt="Next"/)) {
		var as = getElementsByClassName(tds[tds.length-1],'a','*');
		lastPage[divid] = as[as.length-2].innerHTML;
	}
	else  lastPage[divid] = curPage[divid];
	
	sumdiv.innerHTML = parseInt(lastPage[divid])*parseInt(widget.preferenceForKey('ThePirateBayResultsPerPage'))+'+' + ' results found for "' + key + '" in ' + searchIn;

	return torrents;
}


function processMininova(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/no results for/gi)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
	
		return null;
	}
	else {
		var sum = response.innerHTML.match(/Search results for .*?\)/i)[0];
		totalResults[divid] = sum.replace(/Search results for .*?\((\d+) torrents\)/,'$1');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var table = getElementsByClassName(response,'table','maintable')[0]; 
	var tds = getElementsByClassName(table,'td','*');
	var root = 'http://mininova.org';
	var desc = '<div></div>';
	var seeders, leechers, infolink, dllink, nm, id, size;
	var torrents = new Array();
	for (var i=0; i<(tds.length-1)/6; i++) {
		nm = tds[i*6+2].innerHTML.replace(/<\/?a.*?>/gi,'').replace(/<img.*?>/gi,'');
		size = tds[i*6+3].innerHTML;
		seeders = tds[i*6+4].innerHTML.replace(/<\/?span.*?>/gi,'');
		leechers = tds[i*6+5].innerHTML.replace(/<\/?span.*?>/gi,'');
		id = tds[i*6+2].innerHTML.replace(/.*<a href="\/get\/(\d+)".*/i,'$1');
		dllink = root + '/get/' + id;
		infolink = root + '/tor/' + id;
		torrents[i] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}
	return torrents;
}


function processSeedPeer(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/\(0 torrents\)/i)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
	
		return null;
	}
	else {
		var sum = response.innerHTML.match(/<h1>.*?Torrents were found<\/h1>/i)[0];
		totalResults[divid] = sum.replace(/<h1>(\d+) .*? Torrents were found.*/i,'$1');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var table = getElementsByClassName(response,'table','*')[1]; 
//e('tbl: '+table.innerHTML);return;
	var trs = getElementsByClassName(table,'tr','*');
	var root = 'http://www.seedpeer.com';
	var desc = '<div></div>';
	var tds, seeders, leechers, infolink, dllink, nm, id, size;
	var torrents = new Array();
	for (var i=1; i<trs.length; i++) {
		tds = getElementsByClassName(trs[i],'td','*');
		nm = tds[0].innerHTML.replace(/<SPAN class="mx"><\/SPAN>/i,'').replace(/<small>.*?<\/small>/i,'').replace(/<a href="\/details\/\d+.html">/i,'');
		size = tds[2].innerHTML;
		seeders = tds[3].innerHTML;
		leechers = tds[4].innerHTML;
		dllink = "";
		infolink = root + tds[0].innerHTML.replace(/.*?<a href="(.*?)".*/i,'$1');
		torrents[i-1] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}

	return torrents;
}


function processTorrentPortal(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/no torrents found/i)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
	
		return null;
	}
	else {
		var sum = response.innerHTML.match(/\d+ torrent found for/i)[0];
		totalResults[divid] = sum.replace(/(\d+ torrent).*/,'$1s');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var table = response.getElementsByTagName('table')[10];
	var trs = getElementsByClassName(table,'tr','*');
	var root = 'http://torrentportal.com';
	var desc = '<div></div>';
	var tds, seeders, leechers, infolink, dllink, nm, id, size;
	var torrents = new Array();
	for (var i=2; i<trs.length; i+=2) {
		tds = getElementsByClassName(trs[i],'td','*');
		nm = tds[3].innerHTML.replace(/.*<b>(.*?)<\/b>.*/i,'$1');
		size = tds[5].innerHTML;
		seeders = tds[6].innerHTML;
		if (seeders.match("No Stats")) {
			seeders = "X";
			leechers = "X";
		}
		else {
			seeders = seeders.replace(/<\/?b>/gi,'');
			leechers = tds[7].innerHTML.replace(/<\/?b>/gi,'');
		}
		dllink = root + tds[0].innerHTML.replace(/.*?<a href="(\/download.*?\.torrent)".*/i,'$1');
		infolink = root + tds[3].innerHTML.replace(/.*?(\/details.*?.html).*/,'$1');
		torrents[(i-2)/2] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}

	return torrents;
}

// not valid site anymore
function processTorrentReactor(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/no torrents found/i)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
	
		return null;
	}
	else {
		var sum = response.innerHTML.match(/Found \d+ Torrents/)[0];
		totalResults[divid] = sum.replace(/Found (\d+) Torrents/,'$1');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid])/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var table = response.getElementsByTagName('table')[1];
	var trs = getElementsByClassName(table,'tr','*');
	var root = 'http://torrentreactor.com';
	var desc = '<div></div>';
	var seeders, leechers, infolink, dllink, nm, id, size, tds;
	var torrents = new Array();
	for (var i=1; i<trs.length; i++) {
		tds = getElementsByClassName(trs[i],'td','*');
		nm = tds[1].innerHTML.replace(/<\/?a.*?>/gi,'').replace(/<img.*?>/gi,'').replace(/<\/?font.*?>/gi,'');
		size = tds[2].innerHTML;
		seeders = tds[3].innerHTML.replace(/<\/?a.*?>/gi,'').replace(/<\/?font.*?>/gi,'');
		if (seeders=="check")
			seeders = 0;
		leechers = tds[4].innerHTML.replace(/<\/?a.*?>/gi,'').replace(/<\/?font.*?>/gi,'');
		dllink = tds[1].innerHTML.replace(/.*?<a href="(.*?\/torrents\/download_.*?)".*/i,'$1');
		infolink = tds[1].innerHTML.replace(/.*?<a class="tinylink" href="(.*?)".*/i,'$1');
		torrents[i-1] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}
	return torrents;
}



function processDemonoid(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/no torrents found/i)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
	
		return null;
	}
	else {
		var sum = response.innerHTML.match(/(\d+,)?\d+ items total/)[0];
		totalResults[divid] = sum.replace(/(.*?) items total/,'$1');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(",",''))/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var table = response.getElementsByTagName('table')[14];
	var trs = getElementsByClassName(table,'tr','*');

	var root = 'http://demonoid.com';
	var desc = '<div></div>';
	var seeders, leechers, infolink, dllink, nm, id, size;
	var torrents = new Array();
	var adjfactor = 0;
	for (var i=6; i<trs.length-3; i+=2) {
		if (trs[i].innerHTML.match(/Added/)) {
			adjfactor+=1;
			i--;  // only want to advance 1, not 2 on next iteration
		}
		else if (trs[i].innerHTML.match(/Sponsored links/)) {//do nothing
			adjfactor+=2;
		} 
		else {
			nm = trs[i].childNodes[1].innerHTML.replace(/<\/?a.*?>/gi,'');
			size = trs[i+1].childNodes[3].innerHTML;
			seeders = trs[i+1].childNodes[6].innerHTML.replace(/<\/?font.*?>/gi,'');
			leechers = trs[i+1].childNodes[7].innerHTML.replace(/<\/?font.*?>/gi,'');
			dllink = root + trs[i+1].childNodes[2].innerHTML.replace(/.*"(\/files.*?)".*/,'$1')
			infolink = root + trs[i].childNodes[1].innerHTML.replace(/.*?<a href="(.*?)".*/i,'$1');
			torrents[(i-6-adjfactor)/2] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
		}
	}
	return torrents;
}


function processTorrentBox(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/no torrents were found/i)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
	
		return null;
	}
	else {
		response.innerHTML = response.innerHTML.replace(/\n/g,' ');
		var sum = getElementsByClassName(response,'span','pager');
		sum = getElementsByClassName(sum[0], 'p', '*');
		sum = sum[0].innerHTML.replace(/<\/?a.*?>/gi, '').replace(/<\/?b>/gi, '').replace(/<\/?font.*?>/gi, '').replace(/<br.*/i, '');
		var pages = sum.match(/\d+/g);
		totalResults[divid] = pages[pages.length-1];
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid])/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var spans = getElementsByClassName(response, 'span', 'data');
	var trs = getElementsByClassName(spans[spans.length-1],'tr','*');

	var root = 'http://torrentbox.com';
	var desc = '<div></div>';
	var seeders, leechers, infolink, dllink, nm, id, size;
	var torrents = new Array();
	for (var i=1; i<trs.length; i++) {
		nm = trs[i].childNodes[1].innerHTML.replace(/<\/?a.*?>/gi,'').replace(/<\/?font.*?>/gi,'').replace(/<\/?b.*?>/gi,'').replace(/\s\s+/g, '');
		size = trs[i].childNodes[4].innerHTML.replace(/<\/?font.*?>/gi,'');
		seeders = trs[i].childNodes[5].innerHTML.replace(/<\/?font.*?>/gi,'').replace(/<\/?span.*?>/gi,'').replace(/<\/?b.*?>/gi,'');
		leechers = trs[i].childNodes[6].innerHTML.replace(/<\/?font.*?>/gi,'').replace(/<\/?span.*?>/gi,'').replace(/<\/?b.*?>/gi,'');
		dllink = root + trs[i].childNodes[2].innerHTML.replace(/.*"(\/download.*?)".*/,'$1')
		infolink = root + trs[i].childNodes[1].innerHTML.replace(/.*?<a href="(.*?)".*/i,'$1');
		torrents[i-1] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}
	return torrents;
}

// no longer valid site
function processSnarfIt(response, key, divid) {
	// set summary div
	var sumdiv = summaryArr[divid];
	if (response.innerHTML.match(/Of 0 torrents/i)) {
		sumdiv.innerHTML = 'No matches found for "' + key + '".';

		// remove previous results
		resultsArr[divid].innerHTML="";
	
		return null;
	}
	else {
		var sum = response.innerHTML.match(/.* of \d,?\d+ torrents/i)[0];
		totalResults[divid] = sum.replace(/.* of (\d+) torrents/i,'$1');
		lastPage[divid] = Math.ceil(parseInt(totalResults[divid].replace(/,/gi,''))/resultsPerPage[divid]);
		sumdiv.innerHTML = totalResults[divid] + ' results found for "' + key + '" in ' + searchIn;
	}

	var nameArr = getElementsByClassName(response,'div','title');
	var sizeArr = getElementsByClassName(response,'div','size');
	var dlArr = getElementsByClassName(response,'div','downloaders');
	var ulArr = getElementsByClassName(response,'div','uploaders');

	var root = 'http://snarf-it.org';
	var desc = '<div></div>';
	var seeders, leechers, infolink, dllink, nm, id, size;
	var torrents = new Array();
	for (var i=0; i<nameArr.length; i++) {
//opera.postError('lch: '+leechers);
		nm = nameArr[i].innerHTML.replace(/<\/?a.*?>/gi,'');
		size = sizeArr[i+1].innerHTML;
		seeders = ulArr[i+1].innerHTML.replace(/<\/?span.*?>/gi,'');
		leechers = dlArr[i+1].innerHTML.replace(/<\/?span.*?>/gi,'');
		infolink = root + nameArr[i].innerHTML.replace(/.*?(\/viewTorrent.*?.html).*/,'$1');
		dllink = infolink.replace('.html', '.torrent').replace('view', 'download');
		torrents[i] = new Torrent(trimName(nm), infolink, dllink, seeders, leechers, size, desc);
	}

	return torrents;
}


function trimName(name) {
  if (name.length > 30)
     name = name.substr(0,30) + '...';
 
  return name;
}


// add search option to "In Use" list, remove from "Available" list
function addSearch() {
	var availList = document.getElementById("availableList");
	var index = availList.selectedIndex;
  
	if (!(index >= 0))
		return; 

	var name = availList.options[index].value;
	var inuseList = document.getElementById("inUseList");

	widget.setPreferenceForKey('i',name);	
	inuseList.add(new Option(name));	
	availList.remove(index);
	availList.selectedIndex = -1;
  
  	if (inuseList.length == 1)
		curTab = 0;

	widget.setPreferenceForKey('true', 'need refresh');
}


// remove search option from "In Use" list, add to "Available" list
function remSearch() {
	var inuseList = document.getElementById("inUseList");
	var index = inuseList.selectedIndex;
  
	if (!(index >= 0))
		return; 
	if (inuseList.length == 1)
		curTab = -1;
	else if (index == curTab)
		curTab = 0;
	else if (index < curTab)
		curTab--;

	var name = inuseList.options[index].value;
	var availList = document.getElementById("availableList");

	widget.setPreferenceForKey('a',name);
	availList.add(new Option(name));
	inuseList.remove(index);
	inuseList.selectedIndex = -1;

	widget.setPreferenceForKey('true', 'need refresh');
}



/*
    Written by Jonathan Snook, http://www.snook.ca/jonathan
    Add-ons by Robert Nyman, http://www.robertnyman.com
*/
function getElementsByClassName(oElm, strTagName, strClassName) {
    var arrElements = (strTagName == "*" && oElm.all)? oElm.all : oElm.getElementsByTagName(strTagName);
    var arrReturnElements = new Array();
    strClassName = strClassName.replace(/\-/g, "\\-");
    var oRegExp = new RegExp("(^|\\s)" + strClassName + "(\\s|$)");
    var oElement;
    for(var i=0; i<arrElements.length; i++) {
      oElement = arrElements[i];      
      if(oRegExp.test(oElement.className))
        arrReturnElements.push(oElement);
    }
    return (arrReturnElements);
}



var clipLeft = 0;
var clipRight = 356;
var maxWidth = 700;
var left = 45;
var timeout;

function scrollTabs(dir) {
	if (dir.match('left')) {
		if (clipLeft-5 < 0) 
			return;
			
		scroll(-5);
		document.getElementById('rightarrowDiv').style.display = "block";
		
		if (clipLeft==0)
			document.getElementById('leftarrowDiv').style.display = "none";
		
		timeout = setTimeout('scrollTabs("'+dir+'")',20);
	}
	else if (dir.match('right')) {
		if (clipRight+5 > maxWidth) 
			return;
			
		scroll(5);
		document.getElementById('leftarrowDiv').style.display = "block";
		
		if (maxWidth-clipRight < 5)
			document.getElementById('rightarrowDiv').style.display = "none";
		
		timeout = setTimeout('scrollTabs("'+dir+'")',20);
	}
}

function scroll(amount) {
	clipLeft += amount;
	clipRight += amount;
	left -= amount;
	clipstring = 'rect(0px,'+clipRight+'px,50px,'+clipLeft+'px)';
	document.getElementById('tabsList').style.clip = clipstring;
	document.getElementById('tabsList').style.left = left;
}

function stopScroll() { if (timeout) clearTimeout(timeout); }


// called when a selection is made from the search history, copies that text over to the text field.  Gives the illusion of a comboBox.
function syncCombo () {
	selection = document.getElementById('searchSelect');
	document.getElementById('searchText').value = selection.options[selection.selectedIndex].value;
	document.getElementById('searchText').focus();
}